<template>
<!-- Modal -->
<div class="modal fade" id="addNewOrderModal" tabindex="-1" aria-labelledby="addNewOrderModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="addNewOrderModalLabel">Нове замовлення</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form ref="addNewOrderForm" @submit.prevent="addNewOrder()">
                    <div class="form-row mb-3">
                        <div class="col">
                            <label for="formGroupDateFrom">Дата вiдправки</label>
                            <input type="date" v-model="form.dateDeparture" class="form-control" :class="{ 'is-invalid': $v.form.dateDeparture.$error}" id="formGroupDateFrom">
                            <div class="invalid-feedback" v-if="!$v.form.dateDeparture.required">
                                Обов'язкове поле для заповнення.
                            </div>
                        </div>
                        <div class="col">
                            <label for="formGroupDateTo">Дата доставки</label>
                            <input type="date" v-model="form.dateDelivery" class="form-control" :class="{ 'is-invalid': $v.form.dateDelivery.$error }" id="formGroupDateTo">
                            <div class="invalid-feedback" v-if="!$v.form.dateDelivery.required">
                                Обов'язкове поле для заповнення.
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="formGroupFrom">Звiдки</label>
                        <input type="text" v-model="form.fromWhere" class="form-control" :class="{ 'is-invalid': $v.form.fromWhere.$error }" id="formGroupFrom" placeholder="Рiвне">
                        <div class="invalid-feedback" v-if="!$v.form.fromWhere.required">
                            Обов'язкове поле для заповнення.
                        </div>
                        <div class="invalid-feedback" v-if="!$v.form.fromWhere.maxLength">
                            Назва повинна містити не більше {{$v.form.fromWhere.$params.maxLength.max}} букв.
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="formGroupTo">Куди</label>
                        <input type="text" v-model="form.toWhere" class="form-control" :class="{ 'is-invalid': $v.form.toWhere.$error }" id="formGroupTo" placeholder="Ужгород">
                        <div class="invalid-feedback" v-if="!$v.form.toWhere.required">
                            Обов'язкове поле для заповнення.
                        </div>
                        <div class="invalid-feedback" v-if="!$v.form.toWhere.maxLength">
                            Назва повинна містити не більше {{$v.form.toWhere.$params.maxLength.max}} букв.
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="formGroupNameLoad">Назва вантажу</label>
                        <input type="text" v-model="form.name" class="form-control" :class="{ 'is-invalid': $v.form.name.$error }" id="formGroupNameLoad" placeholder="Кукурудза">
                        <div class="invalid-feedback" v-if="!$v.form.name.required">
                            Обов'язкове поле для заповнення.
                        </div>
                        <div class="invalid-feedback" v-if="!$v.form.name.maxLength">
                            Назва повинна містити не більше {{$v.form.name.$params.maxLength.max}} букв.
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="formGroupWeight">Вага (т)</label>
                        <input type="number" v-model="form.weight" min="1" class="form-control" :class="{ 'is-invalid': $v.form.weight.$error }" id="formGroupWeight" placeholder="5">
                        <div class="invalid-feedback" v-if="!$v.form.weight.required">
                            Обов'язкове поле для заповнення.
                        </div>
                        <div class="invalid-feedback" v-if="!$v.form.weight.numeric">
                            Дані повинні бути числові
                        </div>
                    </div>
                    <button type="submit" class="btn btn-primary">Зберегти</button>
                </form>
            </div>
        </div>
    </div>
</div>
</template>

<script>
import {
    mapActions
} from 'vuex';
import {
    required,
    maxLength,
    numeric
} from 'vuelidate/lib/validators';

export default {
    name: 'v-popup',
    data() {
        return {
            form: {
                dateDeparture: null,
                dateDelivery: null,
                fromWhere: null,
                toWhere: null,
                name: null,
                weight: null,
            }
        }
    },
    methods: {
        ...mapActions([
            'GET_LOADS_FROM_API'
        ]),
        addNewOrder() {
            this.$v.form.$touch();
            if (this.$v.form.$anyError) {
                return;
            }
            axios.post('http://127.0.0.1:8000/api/v1/loads', {
                    dates: [this.form.dateDeparture, this.form.dateDelivery],
                    points: [this.form.fromWhere, this.form.toWhere],
                    name: this.form.name,
                    weight: this.form.weight
                })
                .then((response) => {
                    $('#addNewOrderModal').modal('hide');
                    this.$refs.addNewOrderForm.reset();
                })
                .catch(error => {
                    console.error(error.response);
                })
                .finally(() => {
                    this.GET_LOADS_FROM_API();
                });
        },
    },
    validations: {
        form: {
            dateDeparture: {
                required,
            },
            dateDelivery: {
                required,
            },
            fromWhere: {
                required,
                maxLength: maxLength(255)
            },
            toWhere: {
                required,
                maxLength: maxLength(255)
            },
            name: {
                required,
                maxLength: maxLength(255)
            },
            weight: {
                required,
                numeric
            }
        }
    }
}
</script>
